<?
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
require_once("functions.php");

Class Link {
	var $url;
	var $title;

	function Link() {
		$this->url = "";
		$this->title = "";
	}
	
	function loadLine($line) {
		list($this->url, $this->title) = explode(":", rtrim($line));
		$this->url = rtrim(rawurldecode($this->url));
		$this->title = rtrim(rawurldecode($this->title));
	}
	
	function writeLine() {
		return rawurlencode($this->url) . ":" . rawurlencode($this->title);
	}
}

Class Links {
	var $links;
	
	function loadLinks() {
		$this->links = array();
		$lines = array();
		if (file_exists("./lib/links.dat"))
			$lines = file("./lib/links.dat");
		for ($i=0; $i<sizeof($lines); $i++) {
			$link = new Link;
			$link->loadLine($lines[$i]);
			array_push($this->links, $link);
		}
	}
	
	function saveLinks() {
		GLOBAL $readOnly;
		if ($readOnly != 0)
			return;
		if (($f = fopen("./lib/links.dat", "w")) === FALSE)
			exit("Error opening links.dat for writing");
		for ($i=0; $i<sizeof($this->links); $i++)
			fwrite($f, $this->links[$i]->writeLine() . "\n");
		fclose($f);
	}
	
	function addLink($link) {
		GLOBAL $readOnly;
		if ($readOnly != 0)
			return;
		if (($f = fopen("./lib/links.dat", "a")) === FALSE)
			exit("Error opening links.dat for writing");
		fwrite($f, $link->writeLine() . "\n");
		fclose($f);
		array_push($this->links, $link);
	}
	
	function removeItem($index) {
		$tempLinks = array();
		$this->loadLinks();
		for ($i=0; $i<sizeof($this->links); $i++)
			if ($i != $index)
				array_push($tempLinks, $this->links[$i]);
		$this->links = $tempLinks;
		$this->saveLinks();
	}
	
	function moveItem($index, $direction) {
		$this->loadLinks();
		if (!isset($this->links[$index + $direction]))
			return;
		$temp = $this->links[$index];
		$this->links[$index] = $this->links[$index + $direction];
		$this->links[$index + $direction] = $temp;
		$this->saveLinks();
	}

	function writeRSS($title, $baseUrl, $description) {
		GLOBAL $readOnly;
		if ($readOnly != 0)
			return;
		// TODO: write to temp file, then rename/move to final destination
		if (($f = fopen("index.xml", "w")) === FALSE)
			exit("Error opening index.xml for writing");
		fwrite($f, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" .
			"<rss version=\"2.0\">\n" .
			"<channel>\n" .
			"<title>" . $title . "</title>\n" .
			"<language>en-us</language>\n" .
			"<link>" . $baseUrl . "</link>\n" .
			"<description>" . $description . "</description>\n" .
			"<ttl>60</ttl>\n");
		$this->loadLinks();
		for ($i=0; $i<sizeof($this->links); $i++) {
			fwrite($f, "<item>\n" .
			"<title>" . htmlspecialchars($this->links[$i]->title) . "</title>\n" .
			"<link>" . $this->links[$i]->url . "</link>\n" .
			"<guid isPermaLink=\"true\">" . $this->links[$i]->url . "</guid>\n" .
			"</item>\n");
		}
		fwrite($f, "</channel></rss>\n");
		fclose($f);
	}
}
?>