<?
// Rookmarks - tool for administering live RSS bookmarks
// Copyright (C) 2007 Brian Enigma <brian@netninja.com>
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
require_once("functions.php");
define("LEVEL_ADMIN", 		"10");
define("LEVEL_EDITOR", 		"5");

Class User {
	var $name;
	var $level;
	var $passwordHash;
	
	function User() {
		$this->name = "";
		$this->level = 0;
		$this->passwordHash = "";
	}
	
	function loadLine($line) {
		list($this->name, $this->level, $this->passwordHash) = explode(":", rtrim($line));
	}
	
	function writeLine($line) {
		return $this->name . ":" . $this->level . ":" . $this->passwordHash;
	}
}

Class Users {
	var $users;
	
	function loadUsers() {
		$this->users = array();
		$lines = array();
		if (file_exists("./lib/users.dat"))
			$lines = file("./lib/users.dat");
		for ($i=0; $i<sizeof($lines); $i++) {
			$user = new User;
			$user->loadLine($lines[$i]);
			array_push($this->users, $user);
		}
	}
	
	function saveUsers() {
		GLOBAL $readOnly;
		if ($readOnly != 0)
			return;
		if (($f = fopen("./lib/users.dat", "w")) === FALSE)
			exit("Error opening users.dat for writing");
		for ($i=0; $i<sizeof($this->users); $i++)
			fwrite($f, $this->users[$i]->writeLine() . "\n");
		fclose($f);
	}
	
	function getUser($username) {
		reset($this->users);
		while (list($index, $user) = each($this->users))
			if (strcasecmp($user->name, $username) == 0)
				return $user;
		return new User;
	}
	
	function getUserByNameAndPassword($username, $password) {
		reset($this->users);
		while (list($index, $user) = each($this->users))
			if (strcasecmp($user->name, $username) == 0)
				if (strcmp($user->passwordHash, md5($password)) == 0)
					return $user;
		return new User;
	}
	
	function addUser($user) {
		GLOBAL $readOnly;
		if ($readOnly != 0)
			return;
		if (($f = fopen("./lib/users.dat", "a")) === FALSE)
			exit("Error opening users.dat for writing");
		fwrite($f, $user->writeLine() . "\n");
		fclose($f);
		array_push($this->users, $user);
	}
	
	function removeUser($index) {
		$tempUsers = array();
		$this->loadUsers();
		for ($i=0; $i<sizeof($this->users); $i++)
			if ($i != $index)
				array_push($tempUsers, $this->users[$i]);
		$this->users = $tempUsers;
		$this->saveUsers();
	}

	function alterLevel($index, $amount) {
		$this->loadUsers();
		$this->users[$index]->level += $amount;
		if ($this->users[$index]->level < 5)
			$this->users[$index]->level = 5;
		if ($this->users[$index]->level > 10)
			$this->users[$index]->level = 10;
		$this->saveUsers();
	}
	
	function changeMyPassword($current, $new) {
		$me = $_SESSION['rm_username'];
		$this->loadUsers();
		for ($i=0; $i<sizeof($this->users); $i++)
			if (strcasecmp($this->users[$i]->name, $me) == 0) {
				if (strcmp($this->users[$i]->passwordHash, md5($current)) != 0)
					return "Invalid password";
				$this->users[$i]->passwordHash = md5($new);
				$this->saveUsers();
				return "Changed";
			}
		return "Could not find user";
	}
	
}

function isLoggedIn() {
	if (!isset($_SESSION['rm_username']))
	 	return FALSE;
	if (!isset($_SESSION['rm_userlevel']))
	 	return FALSE;
	return (floor($_SESSION['rm_userlevel']) > 0);
}

function attemptLogin($username, $password) {
	GLOBAL $message;
	checkSecurity();
	$users = new Users;
	$users->loadUsers();
	$user = $users->getUserByNameAndPassword($username, $password);
	if ($user->level > 0) {
		$_SESSION['rm_username'] = $user->name;
		$_SESSION['rm_userlevel'] = $user->level;
	}
}

function logout() {
	checkSecurity();
	unset($_SESSION['rm_username']);
	unset($_SESSION['rm_userlevel']);
}

?>